<?php

namespace Controllers;

// use Teknisa\GER\Utilities\Environment;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
// use Zeedhi\Framework\DataSource\Manager;
// use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Message;
use Teknisa\GER\Utilities\DataSourceUtil;
use \Teknisa\GER\Services\CrudService;


class ModpreprecmTabela extends \Teknisa\GER\Controllers\TeknisaCrud  {

	/** @var Environment */
	protected $environment;
	/** @var Manager */
	protected $dataSourceManager;
	protected $dataSourceName = 'modpreprecm';
	protected $dataSourceNameToSave  = false;
    /** @var ParameterBag */
    protected $parameterBag;
    /** @var string[] */
    protected $parameterBagColumns = array();
    protected $dataSourceUtil;


    public function __construct($crudService, $parameterBag, $environment, $dataSourceManager, $dataSourceUtil) {
	    $this->crudService = $crudService;
        $this->parameterBag=$parameterBag;
        $this->environment=$environment;
		$this->dataSourceManager = $dataSourceManager;
        $this->dataSourceUtil = $dataSourceUtil;
	}

	public function find(DTO\Request\Filter $request, DTO\Response $response) {
		
		$filterCriteria = $request->getFilterCriteria();
        $filterCriteria->addCondition("NRORG", "=", $this->environment->getNrOrgTrab());
		$filterCriteria->setDataSourceName($this->dataSourceName);
        $newFilterCriteria = $this->populateParameterBag($filterCriteria);
		$obj = $this->dataSourceManager->findBy($filterCriteria);
		$row = $obj->getRows();
		if($row){
			$row[0]["DSMPREPRECM"] = DataSourceUtil::toPlainText($row[0]["DSMPREPRECM"]);
		}else{
			$row[0] = ["DSMPREPRECM" => ""];
		}
		$response->addDataSet(new DataSet('modpreprecm',$row));
	}
	
	public function getModPrePreCM(DTO\Request\Filter $request, DTO\Response $response) {
		$filterCriteria = $request->getFilterCriteria();
		$filterCriteria->setDataSourceName($this->dataSourceName."_get");
		$res = $this->dataSourceManager->findBy($filterCriteria);
		$responseDataSource = $res->getRows();
        $response->addDataSet(new DataSet("modpreprecm", $responseDataSource));
	}

	public function save(DTO\Request $request, DTO\Response $response) {
		$rows = array();
		$request = $this->buildDataSetIfRow($request);
		foreach ($request->getDataSet()->getRows() as $row) {

			$currentTime = $this->environment->getCurrentTime()->format("d/m/Y H:i:s");

			if ($row['__is_new']) {
				$row['NRORGINCLUSAO'] = $this->environment->getNrOrgTrab();
				$row['DTINCLUSAO'] = $currentTime;
                $row['CDOPERINCLUSAO'] = $this->environment->getCdOperador();
				$row['NRORG'] = $this->environment->getNrOrgTrab();
			}

			$row['IDATIVO'] = isset($row['IDATIVO']) ? ($row['IDATIVO']?: 'S') : 'S';
			$row['CDOPERULTATU'] = $this->environment->getCdOperador();
			$row['DTULTATU'] = $currentTime;
			$row['NRORGULTATU'] = $this->environment->getNrOrgTrab();
			$row['DTULTATUPRFIL'] = $currentTime;

			$rows[] = $row;
		}
		$dataSourceName =  $this->dataSourceNameToSave ?: $this->dataSourceName;
		$dataSet = new DataSet($dataSourceName, $rows);
		$persistedRows = $this->dataSourceManager->persist($dataSet);
        $response->addDataSet(new DataSet($dataSourceName, $persistedRows));
		$nrPersistedRows = count($persistedRows);
		$response->addMessage(new Message("Salvo com sucesso."));
	}

	protected function populateParameterBag(FilterCriteria $filterCriteria) {
        $conditions = array();
        foreach ($filterCriteria->getConditions() as $condition) {
            $columnName = $condition['columnName'];
            if (in_array($columnName, $this->parameterBagColumns)) {
                $this->parameterBag->set($columnName, $this->processConditionValue($condition));
            } else {
                $conditions[] = $condition;
            }
        }

        $newFilterCriteria = new FilterCriteria(
            $filterCriteria->getDataSourceName(),
            $conditions,
            $filterCriteria->getPage(),
            $filterCriteria->getPageSize()
        );

        return $newFilterCriteria;
    }

    protected function buildDataSetIfRow(DTO\Request $request) {
		if ($request instanceof DTO\Request\Row) {
			$dataSet = new DataSet($this->dataSourceName, array((array)$request->getRow()));
			$request = new DTO\Request\DataSet($dataSet, $request->getMethod(), $request->getRoutePath(), $request->getUserId());
		}
		return $request;
	}

}