<?php

namespace Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class PrecoPadraoPrecoProporcional extends \Zeedhi\Framework\Controller\Report {

  protected $environment;
  protected $birtStrategy;

  public function __construct(ReportService $reportService, $birtStrategy, $environment) {
      $this->birtStrategy = $birtStrategy;
      $this->environment = $environment;
      parent::__construct($reportService);
  }

  protected $reportMapping = array (
    'COC21001' =>
    array (
      'strategy' => 'BIRT',
      'parameterMapping' =>
      array (
        "CDFILIAL"         => "CDFILIAL",
        "CDCIA"            => "CDCIA",
        "NRTABPRECO"       => "NRTABPRECO",
        "CDCLASSE"         => "CDCLASSE",
        "CDCICLO"          => "CDCICLO",
        "IDTIPMANUAL"      => "IDTIPMANUAL",
        "NRSERVICOCIAFILI" => "NRSERVICOCIAFILI",
        "IDSERVICO"        => "IDSERVICO",
        "NRORG"            => "NRORG"
      ),
      'reportName'
    )
  );

  public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
    $row = $request->getRow();
    $row['__report_name'] = $row['REPORTNAME'];
    $this->birtStrategy->setReportFormat($row['REPORTFORMAT']);
    $row['NRORG'] = $this->environment->getNrOrgTrab();
  }
  
}