<?php
namespace Controllers;

use Zeedhi\Framework\Report\ReportService;
use \Zeedhi\Framework\DTO;
use \Zeedhi\Framework\DataSource\FilterCriteria;
use \Zeedhi\Framework\DTO\Request\Row;

class RelatorioVersionamentoDoManual extends \Zeedhi\Framework\Controller\Report {

    protected $birtStrategy;

    public function __construct(ReportService $reportService, $birtStrategy) {
        $this->birtStrategy = $birtStrategy;
        parent::__construct($reportService);
    }

    protected $reportMapping = array (
        'COC03800' => array (  //Impressão de Versão do Menu Grid
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
              "NRORG"         =>"NRORG",
              "CDFILIAL"      =>"CDFILIAL",
              "CDMANCIA"      =>"CDMANCIA",
              "NRVERSAO"      =>"NRVERSAO",
              "CDCIA"         =>"CDCIA",
              "CDCLASSE"      =>"CDCLASSE",
              "SERVICOCLASSE" =>"NRSERVICOCIAFILI",
              "SERVCLASSE"    =>"SERVCLASSE",
              "SUBGRUPO"      =>"SUBGRUPO",
              "CICLO"         =>"CDCICLO",
              "FILESERVPATH"  =>"FILESERVPATH",
              "HIDEIMG"       =>"HIDEIMG"
            )
        ),
        'COC03801' => array ( //Comparativo de Versões do Menu Grid
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
              "NRORG"         =>"NRORG",
              "CDFILIAL"      =>"CDFILIAL",
              "CDMANCIA"      =>"CDMANCIA",
              "NRVERSAO"      =>"NRVERSAO",
              "NRVERSAOF"     =>"NRVERSAOF",
              "CDCIA"         =>"CDCIA",
              "CDCLASSE"      =>"CDCLASSE",
              "SERVICOCLASSE" =>"NRSERVICOCIAFILI",
              "SERVCLASSE"    =>"SERVCLASSE",
              "SUBGRUPO"      =>"SUBGRUPO",
              "CICLO"         =>"CDCICLO",
              "FILESERVPATH"  =>"FILESERVPATH",
              "HIDEIMG"       =>"HIDEIMG"
            )
        )
    );

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
      $row = $request->getRow();
      if (isset($row['__locale']) && $row['__locale']){
        $this->birtStrategy->setReportLocale($row['__locale']);
      }
      if (isset($row['__format']) && $row['__format']){
        $this->birtStrategy->setReportFormat($row['__format']);
      }
    }

}